%define anolis_release 10
%undefine _hardened_build
%undefine _strict_symbol_defs_build
%global ansic_major 0
%global ansic_minor 4
%global videodrv_major 24
%global videodrv_minor 1
%global xinput_major 24
%global xinput_minor 1
%global extension_major 10
%global extension_minor 0
%global inst_srcdir %{buildroot}/%{_datadir}/xorg-x11-server-source

Name:      xorg-x11-server
Epoch:     1
Version:   1.20.14
Release:   %{anolis_release}%{?dist}
Summary:   X.Org X11 X server
URL:       http://www.x.org
License:   MIT
Source0:   https://www.x.org/pub/individual/xserver/xorg-server-%{version}.tar.xz
Source1:   10-quirks.conf
Source10:  xserver.pamd
Source20:  http://svn.exactcode.de/t2/trunk/package/xorg/xorg-server/xvfb-run.sh
Source30:  xserver-sdk-abi-requires.release
Source31:  xserver-sdk-abi-requires.git

Patch0: 06_use-intel-only-on-pre-gen4.diff
Patch1: 0001-xfree86-use-modesetting-driver-by-default-on-GeForce.patch
Patch2: 0001-xf86-dri2-Use-va_gl-as-vdpau_driver-for-Intel-i965-G.patch
Patch3: 0001-autobind-GPUs-to-the-screen.patch
Patch4: 0001-Fedora-hack-Make-the-suid-root-wrapper-always-start-.patch
Patch5: 0001-configure.ac-search-for-the-fontrootdir-ourselves.patch

# Backports from "master" upstream:
Patch100: 0001-present-Check-for-NULL-to-prevent-crash.patch
Patch101: 0001-render-Fix-build-with-gcc-12.patch
Patch102: 0001-xf86-Accept-devices-with-the-simpledrm-driver.patch
Patch103: 0001-Don-t-hardcode-fps-for-fake-screen.patch
Patch104: 0001-hw-Rename-boolean-config-value-field-from-bool-to-bo.patch
Patch105: 0001-add-a-quirk-for-apple-silicon.patch

# Fix CVEs
Patch110: 0001-xkb-switch-to-array-index-loops-to-moving-pointers.patch
Patch111: 0002-xkb-swap-XkbSetDeviceInfo-and-XkbSetDeviceInfoCheck.patch
Patch112: 0003-xkb-add-request-length-validation-for-XkbSetGeometry.patch
Patch113: 0001-xkb-proof-GetCountedString-against-request-length-at.patch
Patch114: 0001-xkb-fix-some-possible-memleaks-in-XkbGetKbdByName.patch
Patch115: 0001-Xtest-disallow-GenericEvents-in-XTestSwapFakeInput.patch
Patch116: 0002-Xi-return-an-error-from-XI-property-changes-if-verif.patch
Patch117: 0003-Xi-avoid-integer-truncation-in-length-check-of-ProcX.patch
Patch118: 0004-Xi-disallow-passive-grabs-with-a-detail-255.patch
Patch119: 0005-Xext-free-the-screen-saver-resource-when-replacing-i.patch
Patch120: 0006-Xext-free-the-XvRTVideoNotify-when-turning-off-from-.patch
Patch121: 0007-xkb-reset-the-radio_groups-pointer-to-NULL-after-fre.patch
Patch122: 0008-Xext-fix-invalid-event-type-mask-in-XTestSwapFakeInp.patch
Patch123: 0001-Xi-fix-potential-use-after-free-in-DeepCopyPointerCl.patch
Patch124: 0001-composite-Fix-use-after-free-of-the-COW.patch
Patch126: 0001-present-Send-a-PresentConfigureNotify-event-for-dest.patch

Patch200: 0001-Disallow-byte-swapped-clients-by-default.patch

Patch1000: 1000-meson-Fix-libshadow.so-linkage.patch
Patch1001: 1001-xfree86-Link-fb-statically.patch
Patch1002: 1002-xfree86-Merge-vbe-into-int10.patch
Patch1003: 1003-loader-Move-LoaderSymbolFromModule-to-public-API.patch
Patch1004: 1004-modesetting-Indirect-the-shadow-API-through-LoaderSy.patch
Patch1005: 1005-modesetting-Indirect-the-glamor-API-through-LoaderSy.patch
Patch1006: 1006-link-gbm-lib.patch
Patch1007: 1007-do-not-link-glamor-directly.patch
Patch1008: 1008-Use-glamor_clear_pixmap-in-drmmode_clear_pixmap.patch
Patch1009: 1009-Fix-build-with-glamor-disabled.patch
Patch1010: 1010-Make-LoaderSymbolFromModule-take-a-ModuleDescPtr.patch
Patch1011: 1011-fix-call-systemd_logind_vtenter-after-receiving-drm-device-resume.patch
Patch1012: 1012-Fix-drm_drop_master-before-vt_reldisp.patch
Patch1013: 1013-Fix-compilation-error-when-built-without-logind_platform-bus.patch
Patch1014: 1014-fix-missing-call-to-vtenter-if-the-platform-device-is-not-paused.patch
Patch1015: 1015-x86_logind-fix-suspend_resume-when-there-are-no-input-devices.patch

BuildRequires: automake make autoconf libtool pkgconfig
BuildRequires: dbus-devel libepoxy-devel libudev-devel systemd-devel systemtap-sdt-devel
BuildRequires: libXfont2-devel libXau-devel libxkbfile-devel libXres-devel libXpm-devel
BuildRequires: libX11-devel libXi-devel libXext-devel libXinerama-devel libfontenc-devel
BuildRequires: libXt-devel libdmx-devel libXfixes-devel libXmu-devel libXrender-devel
BuildRequires: libXaw-devel libXtst-devel libXdmcp-devel libXv-devel libdrm-devel >= 2.4.0
BuildRequires: libpciaccess-devel >= 0.13.1 openssl-devel bison flex
BuildRequires: mesa-libEGL-devel mesa-libgbm-devel mesa-libGL-devel >= 9.2
BuildRequires: libunwind-devel kernel-headers pixman-devel >= 0.30.0
BuildRequires: audit-libs-devel libselinux-devel >= 2.0.86-1
BuildRequires: pkgconfig(xcb-aux) pkgconfig(epoxy) pkgconfig(xcb-image) pkgconfig(xcb-icccm)
BuildRequires: pkgconfig(xcb-keysyms) pkgconfig(xshmfence) >= 1.1 pkgconfig(xcb-renderutil)
BuildRequires: xorg-x11-util-macros >= 1.17 xorg-x11-proto-devel >= 7.7-10
BuildRequires: xorg-x11-xtrans-devel >= 1.3.2 xorg-x11-font-utils >= 7.2-11

%description
X.Org X11 X server

%package common
Summary: Xorg server common files
Requires: pixman >= 0.30.0 xkeyboard-config xkbcomp

%description common
Common files shared among all X servers.

%package Xorg
Summary: Xorg X server
Provides: Xorg = %{EVR}
Provides: Xserver
Provides: xorg-x11-server-wrapper = %{EVR}
Provides: xserver-abi(ansic-%{ansic_major}) = %{ansic_minor}
Provides: xserver-abi(videodrv-%{videodrv_major}) = %{videodrv_minor}
Provides: xserver-abi(xinput-%{xinput_major}) = %{xinput_minor}
Provides: xserver-abi(extension-%{extension_major}) = %{extension_minor}
Provides: xorg-x11-glamor = %{EVR}
Obsoletes: xorg-x11-glamor < %{EVR}
Obsoletes: xorg-x11-drv-modesetting < %{EVR}
Provides: xorg-x11-drv-modesetting = %{EVR}
Obsoletes: xorg-x11-drv-vmmouse < 13.1.0-4

Requires: xorg-x11-server-common == %{EVR}
Requires: system-setup-keyboard xorg-x11-drv-libinput libEGL

%description Xorg
X.org X11 is an open source implementation of the X Window System.  It
provides the basic low level functionality which full fledged
graphical user interfaces (GUIs) such as GNOME and KDE are designed
upon.

%package Xnest
Summary: A nested server
Requires: xorg-x11-server-common == %{EVR}
Provides: Xnest

%description Xnest
Xnest is an X server which has been implemented as an ordinary
X application.  It runs in a window just like other X applications,
but it is an X server itself in which you can run other software.

%package Xdmx
Summary: Distributed Multihead X Server and utilities
Requires: xorg-x11-server-common == %{EVR}
Provides: Xdmx

%description Xdmx
Xdmx is proxy X server that provides multi-head support for multiple displays
attached to different machines (each of which is running a typical X server).

%package Xvfb
Summary: A X Windows System virtual framebuffer X server
License: MIT and GPLv2
Requires: xorg-x11-server-common = %{EVR}
Requires: xorg-x11-xauth
Provides: Xvfb

%description Xvfb
Xvfb (X Virtual Frame Buffer) is an X server that is able to run on
machines with no display hardware and no physical input devices.

%package Xephyr
Summary: A nested server
Requires: xorg-x11-server-common == %{EVR}
Provides: Xephyr

%description Xephyr
Xephyr is a a kdrive server that outputs to a window on a pre-existing
'host' X display. Think Xnest but with support for modern extensions
like composite, damage and randr.

Unlike Xnest which is an X proxy, i.e.  limited to the
capabilities of the host X server, Xephyr is a real X server which
uses the host X server window as "framebuffer" via fast SHM XImages.

It also has support for 'visually' debugging what the server is
painting.

%package devel
Summary: SDK for X server driver module development
Requires: xorg-x11-util-macros xorg-x11-proto-devel
Requires: libXfont2-devel pkgconfig pixman-devel libpciaccess-devel

Provides: xorg-x11-server-static
Obsoletes: xorg-x11-glamor-devel < %{EVR}
Provides: xorg-x11-glamor-devel = %{EVR}

%description devel
The SDK package contains the developmental files which are necessary for
developing X server driver modules, and for compiling driver modules
outside of the standard X11 source code tree.
You should install this package if you are writing video drivers,
input drivers, or other X modules.

%package source
Summary: Xserver source code required to build VNC server (Xvnc)
BuildArch: noarch

%description source
Xserver source code needed to build VNC server (Xvnc).

%prep
%autosetup -p1 -n xorg-server-%{version}

getmajor() {
    grep -i ^#define.ABI.$1_VERSION hw/xfree86/common/xf86Module.h |
    tr '(),' '   ' | awk '{ print $4 }'
}

getminor() {
    grep -i ^#define.ABI.$1_VERSION hw/xfree86/common/xf86Module.h |
    tr '(),' '   ' | awk '{ print $5 }'
}

test `getmajor ansic` == %{ansic_major}
test `getminor ansic` == %{ansic_minor}
test `getmajor videodrv` == %{videodrv_major}
test `getminor videodrv` == %{videodrv_minor}
test `getmajor xinput` == %{xinput_major}
test `getminor xinput` == %{xinput_minor}
test `getmajor extension` == %{extension_major}
test `getminor extension` == %{extension_minor}

%build
autoreconf -fiv

%configure --enable-xvfb \
	--enable-xnest \
	--enable-kdrive \
	--enable-xephyr \
	--enable-xorg \
	--enable-xselinux \
	--enable-record \
	--enable-present \
        --enable-xcsecurity \
	--enable-config-udev \
	--enable-dmx \
	--enable-dependency-tracking \
	--disable-xwayland \
	--disable-linux-apm \
	--disable-static \
	--disable-unit-tests \
	--disable-linux-acpi \
	--disable-dri \
	--enable-dri2 \
	--enable-dri3 \
	--enable-suid-wrapper \
	--enable-glamor \
	--with-pic \
	--with-default-font-path="catalogue:/etc/X11/fontpath.d,built-ins" \
	--with-module-dir=%{_libdir}/xorg/modules \
	--with-builderstring="Build ID: %{name} %{version}-%{release}" \
	--with-os-name="%{_vendor} $(uname -r)" \
	--with-xkb-output=%{_localstatedir}/lib/xkb \
        --without-dtrace \
%ifnarch x86_64
	--disable-vbe \
	--disable-int10-module \
%endif
	${CONFIGURE}

%make_build

%install
%make_install

mkdir -p $RPM_BUILD_ROOT%{_libdir}/xorg/modules/{drivers,input}

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/pam.d
install -p -m 644 %{SOURCE10} $RPM_BUILD_ROOT%{_sysconfdir}/pam.d/xserver

mkdir -p $RPM_BUILD_ROOT%{_datadir}/X11/xorg.conf.d
install -p -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{_datadir}/X11/xorg.conf.d

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/X11/xorg.conf.d
install -p -m 755 %{SOURCE30} $RPM_BUILD_ROOT%{_bindir}/xserver-sdk-abi-requires
install -p -m 0755 %{SOURCE20} $RPM_BUILD_ROOT%{_bindir}/xvfb-run

mkdir -p %{inst_srcdir}/{Xext,xkb,GL,hw/{xquartz/bundle,xfree86/common}}
mkdir -p %{inst_srcdir}/{hw/dmx/doc,man,doc,hw/dmx/doxygen}
for f in hw/xquartz/bundle/cpprules.in man/Xserver.man doc/smartsched hw/dmx/doxygen/doxygen.conf.in xserver.ent.in hw/xfree86/Xorg.sh.in; do
	cp -p $f %{inst_srcdir}
done
install -p xkb/README.compiled %{inst_srcdir}/xkb
install -p  hw/xfree86/xorgconf.cpp %{inst_srcdir}/hw/xfree86

find . -type f | egrep '.*\.(c|h|am|ac|inc|m4|h.in|pc.in|man.pre|pl|txt)$' |
xargs tar cf - | (cd %{inst_srcdir} && tar xf -)
find %{inst_srcdir}/hw/xfree86 -name \*.c -delete

%ifnarch x86_64
rm -f $RPM_BUILD_ROOT%{_libdir}/xorg/modules/lib{int10,vbe}.so
%endif

%files common
%{_libdir}/xorg/protocol.txt
%dir %{_localstatedir}/lib/xkb
%{_localstatedir}/lib/xkb/README.compiled
%{_mandir}/man1/Xserver.1*
%license COPYING

%files Xorg
%dir %{_sysconfdir}/X11/xorg.conf.d
%config %attr(0644,root,root) %{_sysconfdir}/pam.d/xserver
%{_bindir}/X
%{_bindir}/Xorg
%{_bindir}/cvt
%{_bindir}/gtf
%{_libexecdir}/Xorg
%attr(4755, root, root) %{_libexecdir}/Xorg.wrap

%dir %{_libdir}/xorg
%dir %{_libdir}/xorg/modules
%dir %{_libdir}/xorg/modules/drivers
%dir %{_libdir}/xorg/modules/extensions
%dir %{_libdir}/xorg/modules/input
%{_libdir}/xorg/modules/drivers/modesetting_drv.so
%{_libdir}/xorg/modules/extensions/libglx.so
%{_libdir}/xorg/modules/libfbdevhw.so
%{_libdir}/xorg/modules/libexa.so
%{_libdir}/xorg/modules/libglamoregl.so
%{_libdir}/xorg/modules/libshadow.so
%{_libdir}/xorg/modules/libshadowfb.so
%{_libdir}/xorg/modules/libvgahw.so
%{_libdir}/xorg/modules/libwfb.so
%ifarch x86_64
%{_libdir}/xorg/modules/libint10.so
%endif
%dir %{_datadir}/X11/xorg.conf.d
%{_datadir}/X11/xorg.conf.d/10-quirks.conf

%{_mandir}/man1/gtf.1*
%{_mandir}/man1/Xorg.1*
%{_mandir}/man1/Xorg.wrap.1*
%{_mandir}/man1/cvt.1*
%{_mandir}/man4/fbdevhw.4*
%{_mandir}/man4/exa.4*
%{_mandir}/man4/modesetting.4*
%{_mandir}/man5/Xwrapper.config.5*
%{_mandir}/man5/xorg.conf.5*
%{_mandir}/man5/xorg.conf.d.5*
%license COPYING

%files Xnest
%{_bindir}/Xnest
%{_mandir}/man1/Xnest.1*

%files Xdmx
%{_bindir}/Xdmx
%{_bindir}/dmxaddinput
%{_bindir}/dmxaddscreen
%{_bindir}/dmxreconfig
%{_bindir}/dmxresize
%{_bindir}/dmxrminput
%{_bindir}/dmxrmscreen
%{_bindir}/dmxtodmx
%{_bindir}/dmxwininfo
%{_bindir}/vdltodmx
%{_bindir}/dmxinfo
%{_bindir}/xdmxconfig
%{_mandir}/man1/Xdmx.1*
%{_mandir}/man1/dmxtodmx.1*
%{_mandir}/man1/vdltodmx.1*
%{_mandir}/man1/xdmxconfig.1*

%files Xvfb
%{_bindir}/Xvfb
%{_bindir}/xvfb-run
%{_mandir}/man1/Xvfb.1*

%files Xephyr
%{_bindir}/Xephyr
%{_mandir}/man1/Xephyr.1*

%files devel
%{_bindir}/xserver-sdk-abi-requires
%{_libdir}/pkgconfig/xorg-server.pc
%dir %{_includedir}/xorg
%{_includedir}/xorg/*.h
%{_datadir}/aclocal/xorg-server.m4
%license COPYING

%files source
%{_datadir}/xorg-x11-server-source

%changelog
* Fri Jun 30 2023 Liwei Ge <liwei.glw@alibaba-inc.com> - 1:1.20.14-10
- prevent login stuck from resuming

* Wed May 31 2023 Funda Wang <fundawang@yeah.net> - 1:1.20.14-9
- Fix CVE-2023-1393

* Wed Apr 19 2023 Liwei Ge <liwei.glw@alibaba-inc.com> - 1:1.20.14-8
- make modesetting link gbm

* Wed Apr 19 2023 Liwei Ge <liwei.glw@alibaba-inc.com> - 1:1.20.14-7
- make build fit ld -z now

* Fri Apr 14 2023 Yuanhong Peng <yummypeng@linux.alibaba.com> - 1:1.20.14-6
- Refactor the specfile

* Sun Feb 26 2023 Funda Wang <fundawang@yeah.net> - 1:1.20.14-5
- Sync with upstream patches

* Thu Dec 15 2022 Funda Wang <fundawang@yeah.net> - 1:1.20.14-4
- Disable int10 only under non-x86 arch

* Tue Oct 25 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 1:1.20.14-3
- xf86: Accept devices with the 'simpledrm' driver

* Tue Jul 12 2022 happy_orange <songnannan@linux.alibaba.com> - 1:1.20.14-2
- bugfix the some xorg modules loading error in iso

* Fri Apr 22 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 1:1.20.14-1
- Init from upstream version 1.20.14
